function [x]= elim_gausspsim(d,u,v,b)
% Efolio-B - Andreia Romao 1702430
% Questão 1.5
%
% x=elim_gausspsim(d,u,v,b)
%
%Resolve sistemas de n equações lineares pentadiagonais simétricos
% pelo método de eliminação de Gauss
%
%d,u,v são vetores de dimensão n contendo as linhas
% diagonais da matriz A
% u(n),v(n-1) e v(n) não são usados
% x é um vetor coluna

n=size(d,2);
x=zeros(n,1);

for k=1:n-2
  ml=u(k)/d(k); % multiplicador de l
  % transformar em triangular superior
  d(k+1)=d(k+1)-ml*u(k); % mexe no elemento d(k+1)
  u(k+1)=u(k+1)-ml*v(k); % mexe no elemento u(k+1)
  b(k+1)=b(k+1)-ml*b(k); % mexe no elemento b(k+1)

  mh=v(k)/d(k); % multiplicador de h
  % transformar em triangular superior
  d(k+2)=d(k+2)-mh*v(k); % mexe no elemento d(k+2)
  b(k+2)=b(k+2)-mh*b(k); % mexe no elemento b(k+2)

end
% eliminar a linha que tem o elemento l(n)
ml=u(n-1)/d(n-1); % multiplicador de l
d(n)=d(n)-ml*u(n-1); % mexe no elemento d(n)
b(n)=b(n)-ml*b(n-1); % mexe no elemento b(n)


% obter a solução de x(n) e x(n-1)
x(n)=b(n)/d(n);
x(n-1)=(b(n-1)-(u(n-1)*x(n)))/d(n-1);

% resolver por substituição inversa Ux=y, B=[U y]
for k=n-2:-1:1
  x(k)=(b(k)-(u(k)*x(k+1))-(v(k)*x(k+2)))/d(k);
end
% EOF
